#include "CustomRulerWidget.h"

CustomRulerWidget::CustomRulerWidget(QAbstractScrollArea *parent, Qt::Orientation style)
	: QWidget(parent)
{
}

CustomRulerWidget::~CustomRulerWidget()
{
}

void CustomRulerWidget::DrawHorizontalScale(QPainter *painter, QPen *pen)
{
	//TODOƣˮƽ̶ȳ

	//һˮƽ
	QPoint ptBegin(m_ptZero.x(), m_ptZero.y());
	QPoint ptEnd(this->rect().width(), m_ptZero.y());
	painter->drawLine(ptBegin, ptEnd);
	//ƿ̶
	float fDrawLeft = m_ptZero.x();
	int nIndex = 0;
	int nScaleHeight = 20; //̶߸߶
	while (fDrawLeft < this->rect().width())
	{
		if ((nIndex % 2 == 0) && (nIndex % 5 == 0))
		{
			pen->setWidth(2);
			painter->setPen(*pen);
			//ƿ̶ֵ
			nScaleHeight = 15;
			//ı
			QString sText = QString::number(nIndex / 10) + m_qsUnit;
			painter->drawText(QPoint(fDrawLeft, m_ptZero.y() + nScaleHeight + 15), sText);
		}
		else
		{
			pen->setWidth(1);
			painter->setPen(*pen);
			//мڵʱҪһĳ
			nScaleHeight = (nIndex % 5) == 0 ? 10 : 6;
		}
		//ƿ̶ֵ
		painter->drawRect(QRectF(fDrawLeft, m_ptZero.y(), 0.1, nScaleHeight));

		fDrawLeft += m_fInterval * m_fZoom;
		nIndex += 1;
	}
}

void CustomRulerWidget::DrawVerticalScale(QPainter *painter, QPen *pen)
{
	//TODOƣ̶ֱȳ
	pen->setWidth(2);
	painter->setPen(*pen);
	//һֱ
	QPoint ptBegin(m_ptZero.x(), 0);
	QPoint ptEnd(m_ptZero.x(), m_ptZero.y());
	painter->drawLine(ptBegin, ptEnd);
	//ƿ̶ߣϻƿ̶ֵ
	float fDrawTop = ptEnd.y();
	int nIndex = 0;
	int nScaleWidth = 20; //̶߿
	while (fDrawTop >= 0)
	{
		if ((nIndex % 2 == 0) && (nIndex % 5 == 0))
		{
			pen->setWidth(2);
			painter->setPen(*pen);
			//ƿ̶ֵ
			nScaleWidth = 15;
			//ı
			QString sText = QString::number(nIndex / 10) + m_qsUnit;
			int fontWidth = fontMetrics().width(sText);
			int nleft = ((m_ptZero.x() - nScaleWidth) - fontWidth) / 2;
			painter->drawText(QPoint(nleft, fDrawTop), sText);
		}
		else
		{
			pen->setWidth(1);
			painter->setPen(*pen);
			//мڵʱҪһĳ
			nScaleWidth = (nIndex % 5) == 0 ? 10 : 6;
		}
		//ƿ̶ֵ
		painter->drawRect(QRectF(m_ptZero.x() - nScaleWidth, fDrawTop, nScaleWidth, 0.1));

		fDrawTop -= m_fInterval * m_fZoom;
		nIndex += 1;
	}
}

void CustomRulerWidget::paintEvent(QPaintEvent *event)
{
	QPainter painter(this);
	//屳ɫ
	painter.fillRect(this->rect(), QColor(220, 220, 220));
	//
	QFont font(QStringLiteral("Microsoft YaHei"), 9);
	painter.setFont(font);
	//ûˢ
	QPen pen(Qt::black, 1);
	pen.setWidth(1);
	painter.setPen(pen);
	painter.translate(0, 0);
	//ݻ
	painter.setRenderHint(QPainter::Antialiasing);
	if (m_style == Qt::Horizontal)
	{
		//ˮƽ̶ȳ
		this->DrawHorizontalScale(&painter, &pen);
	}
	else
	{
		//ƴ̶ֱȳ
		this->DrawVerticalScale(&painter, &pen);
	}

}

void CustomRulerWidget::resizeEvent(QResizeEvent *event)
{
	if (m_style == Qt::Horizontal)
	{
		//ˮƽ
		int nLeft = this->width() / 28;
		m_ptZero.setX(45);
		m_ptZero.setY(1);
	}
	else
	{
		//ֱ
		int nLeft = this->width() - 1;
		m_ptZero.setX(nLeft);
		m_ptZero.setY(this->height() - 1);
	}
	//̶ȳ߼С4
	float nCalcInterval = this->width() / 320.0;
	m_fInterval = nCalcInterval <= 4 ? 4.0 : nCalcInterval;
	QWidget::resizeEvent(event);
}