#include "DcmDataDlg.h"

template<typename T>
void GenerateItems(QList<QTreeWidgetItem *> &items, T &t)
{
	DcmList *elementList = t.GetDcmList();
	if (!elementList->empty())
	{
		DcmObject *dO;
		DcmTag tag;
		OFString value;
		elementList->seek(ELP_first);
		do {
			dO = elementList->get();
			tag = dO->getTag();
			DcmElement *elem;
			t.findAndGetElement(tag, elem);
			elem->getOFString(value, 0);

			QTreeWidgetItem *tmp_item = new QTreeWidgetItem;

			tmp_item->setText(0, QString::fromLocal8Bit(tag.toString().c_str()));
			tmp_item->setText(1, tag.getVRName());
			tmp_item->setText(2, QString::number(dO->getLength()));
			tmp_item->setText(3, QString::number(dO->getVM()));
			tmp_item->setText(4, tag.getTagName());
			tmp_item->setText(5, QString::fromLocal8Bit(value.c_str()));

			if (EVR_SQ == dO->getVR())
			{
				QList<QTreeWidgetItem *> tmp_items;
				DcmItem *sq;
				t.findAndGetSequenceItem(dO->getTag(), sq);
				MywDcmItem *dcmitem_info = new MywDcmItem(*sq);
				GenerateItems(tmp_items, *dcmitem_info);
				tmp_item->addChildren(tmp_items);
			}
			items << tmp_item;
		} 
		while (elementList->seek(ELP_next));
		delete dO;
	}
}

bool DcmDataDlg::SearchChild(QTreeWidgetItem *Item, QString &text, int mindex)
{
	bool bshow = false;    //øڵµӽڵ    
	int childCount = Item->childCount();

	for (int n = 0; n < childCount;  ++n)
	{
		QTreeWidgetItem *  CurChidItm = Item->child(n); 
		if (SearchChild(CurChidItm, text, mindex))
		{
			CurChidItm->setHidden(true);
			bshow = true;
			continue;
		}
		QString ChilNodText = CurChidItm->text(mindex);
		bool IsContain = ChilNodText.contains(text, Qt::CaseInsensitive);//ڵǷؼ        
		if (IsContain) //ؼƥ      
		{
			CurChidItm->setHidden(false);//ʾڵ            
			bshow = true;
			continue;
		}
		else
		{
			CurChidItm->setHidden(true);//ؽڵ    
		}
	}
	return bshow;
}

bool DcmDataDlg::unSearchChild(QTreeWidgetItem * Item)
{
	bool bshow = false;    //øڵµӽڵ    
	int childCount = Item->childCount();

	for (int n = 0; n < childCount; ++n)
	{
		QTreeWidgetItem *  CurChidItm = Item->child(n);
		if (unSearchChild(CurChidItm))
		{
			CurChidItm->setHidden(false);
			bshow = true;
			continue;
		}
		CurChidItm->setHidden(false);//ʾڵ            
		bshow = true;
	}
	return bshow;
}

void DcmDataDlg::Search(int mindex)
{
	QString  searchword = ui.lineEdit_search->text();//ҵ    
	if (searchword != "")
	{
		int ItemCount = ui.treeWidget_DcmTag->topLevelItemCount();
		for (int m = 0; m < ItemCount; ++m)//иڵ   
		{
			QTreeWidgetItem * CurTopLevItm = ui.treeWidget_DcmTag->topLevelItem(m); //ʾؼƥ        
			QString TopNodText = CurTopLevItm->text(0);

			if ((TopNodText != "Dicom-MetaInfo") && (TopNodText != "Dicom-Data-Set"))
			{
				if (SearchChild(CurTopLevItm, searchword, mindex))
				{
					CurTopLevItm->setHidden(false);
					continue;
				}
				QString Text = CurTopLevItm->text(mindex);
				bool IsContain = Text.contains(searchword, Qt::CaseInsensitive);  //ڵǷؼ        
				if (IsContain)
				{
					CurTopLevItm->setHidden(false);//ʾ˽ڵ     
				}
				else
				{
					CurTopLevItm->setHidden(true);
				}
			}
			else
			{
				CurTopLevItm->setHidden(true);
			}
		}
		ui.treeWidget_DcmTag->expandAll();//չнڵ}Ƭ
	}
	else
	{
		unSearch();
	}
}

void DcmDataDlg::unSearch()
{
	ui.lineEdit_search->setText("");
	int ItemCount = ui.treeWidget_DcmTag->topLevelItemCount();
	for (int m = 0; m < ItemCount; ++m)//иڵ   
	{
		QTreeWidgetItem * CurTopLevItm = ui.treeWidget_DcmTag->topLevelItem(m); //ʾؼƥ      
		if (unSearchChild(CurTopLevItm))
		{
			CurTopLevItm->setHidden(false);
			continue;
		}
		CurTopLevItm->setHidden(false);//ʾ˽ڵ  
	}
}

DcmDataDlg::DcmDataDlg(QWidget *parent)	: QWidget(parent)
{
	ui.setupUi(this);
	//this->setWindowFlags(Qt::Dialog | Qt::WindowCloseButtonHint);

	ui.lineEdit_DcmName->setContextMenuPolicy(Qt::NoContextMenu);
	ui.lineEdit_DcmName->setFocusPolicy(Qt::NoFocus);
	ui.lineEdit_DcmName->setVisible(false);

	ui.treeWidget_DcmTag->setHeaderLabels(QStringList() << "Tag ID" << "VR" << "VM" << "Length" << "Description" << "Value");
	ui.treeWidget_DcmTag->setColumnWidth(0, 200);
	ui.treeWidget_DcmTag->setColumnWidth(1, 70);
	ui.treeWidget_DcmTag->setColumnWidth(2, 100);
	ui.treeWidget_DcmTag->setColumnWidth(3, 50);
	ui.treeWidget_DcmTag->setColumnWidth(4, 300);
	ui.treeWidget_DcmTag->setColumnWidth(5, 300);
	ui.treeWidget_DcmTag->setGeometry(0, 0, 1200, 800);

	ui.comboBox->addItem("Tag ID"); 
	ui.comboBox->addItem("Description");
	ui.comboBox->addItem("Value");

	 //m_itemBrush = ui.treeWidget_DcmTag->topLevelItem(0)->background(0);
}

DcmDataDlg::~DcmDataDlg()
{
}

void DcmDataDlg::on_pushButton_clicked()
{
	close();
}

void DcmDataDlg::setText(QString m_text)
{
	if (m_text != "")
	{
		ui.lineEdit_DcmName->setText(m_text);
		//ui.treeWidget_DcmTag->c
		QList<QTreeWidgetItem *> items;
		// ȡļ
		DcmFileFormat dfile;
		dfile.loadFile(OFFilename(m_text.toLocal8Bit()));

		QTreeWidgetItem *metainfo_item = new QTreeWidgetItem;
		metainfo_item->setText(0, "Dicom-MetaInfo");
		items << metainfo_item;
		MyDcmMetaInfo *meta_info = new MyDcmMetaInfo(*dfile.getMetaInfo());
		GenerateItems(items, *meta_info);
		QTreeWidgetItem *dataset_item = new QTreeWidgetItem;
		dataset_item->setText(0, "Dicom-Data-Set");
		items << dataset_item;
		MyDcmDataset *dataset_info = new MyDcmDataset(*dfile.getDataset());
		GenerateItems(items, *dataset_info);
		// ʾ
		ui.treeWidget_DcmTag->addTopLevelItems(items); 
		m_itemBrush = ui.treeWidget_DcmTag->topLevelItem(0)->background(0);
	}
}

void DcmDataDlg::on_pushButton_search_clicked()
{
	QString strTxt = ui.comboBox->currentText();//ȡcomboBoxѡ
	if (strTxt == "Tag ID")
	{
		Search(0);
		return;
	}
	if (strTxt == "Description")
	{
		Search(4);
		return;
	}
	if (strTxt == "Value")
	{
		Search(5);
		return;
	}
	//Search(5);
}

void DcmDataDlg::on_pushButton_2_clicked()
{
	unSearch();
}

void DcmDataDlg::on_comboBox_currentIndexChanged(QString s)
{
	on_pushButton_search_clicked();
}
