#pragma once

#include <QWidget>
#include "dcmtk/dcmdata/dctk.h"
#include "ui_DcmDataDlg.h"

template<typename T>
class NewDcmItem : public T 
{
public:
	NewDcmItem(const T &old) : T(old) 
	{
	}
	DcmList *GetDcmList()const 
	{
		return this->elementList;
	}
protected:
	virtual ~NewDcmItem() {}
};

using MyDcmDataset = NewDcmItem<DcmDataset>;
using MyDcmMetaInfo = NewDcmItem<DcmMetaInfo>;
using MywDcmItem = NewDcmItem<DcmItem>;

class DcmDataDlg : public QWidget
{
	Q_OBJECT

public:
	DcmDataDlg(QWidget *parent = Q_NULLPTR);
	~DcmDataDlg();
	
	bool SearchChild(QTreeWidgetItem * Item, QString & text, int mindex);
	bool unSearchChild(QTreeWidgetItem * Item);

	void Search(int mindex);
	void unSearch();
	void setText(QString m_text);
	
public slots:	
	void on_comboBox_currentIndexChanged(QString s);
	void on_pushButton_clicked();
	void on_pushButton_search_clicked();
	void on_pushButton_2_clicked();
private:
	Ui::DcmDataDlg ui; 
	QBrush m_itemBrush;

};
