#include "DicomItem.h"
#include <QPen>
#include <QBrush>
#include <QPainter>
#include <QGraphicsScene>
#include <QCursor>

void MyPathItem::paint(QPainter * painter, const QStyleOptionGraphicsItem * option, QWidget * widget)
{
	QStyleOptionGraphicsItem op(*option);
	op.initFrom(widget);
	op.state = QStyle::State_None;
	QGraphicsPathItem::paint(painter, &op, widget);
}

//***************************************************************************************************************

DicomItem::DicomItem(QPointF p, QGraphicsItem* parent)
	: m_point(p)
	, QGraphicsItem(parent)
{
	setFlags(QGraphicsItem::ItemIsFocusable | QGraphicsItem::ItemIsSelectable | QGraphicsItem::ItemIsMovable);
	this->setCursor(Qt::PointingHandCursor);
}

DicomItem::~DicomItem()
{
}

QRectF DicomItem::boundingRect() const
{
	return QRectF(-4, -4, 8, 8);
	//return QRectF(2, 2, 4, 4);
}

void DicomItem::paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget)
{
	Q_UNUSED(option);
	Q_UNUSED(widget);
	QPen pen(Qt::yellow, 1);
	QBrush brush(Qt::blue);
	this->setPos(m_point);
	painter->setPen(pen);
	painter->setBrush(brush);
	painter->drawEllipse(-4, -4, 8, 8);
	//painter->drawEllipse(2, 2, 4, 4);
}

void DicomItem::mouseMoveEvent(QGraphicsSceneMouseEvent *e)
{
	if (e->buttons() == Qt::LeftButton) {
		qreal x = e->scenePos().x() - e->lastScenePos().x();
		qreal y = e->scenePos().y() - e->lastScenePos().y();
		this->parentItem()->moveBy(x, y);
	}
	return QGraphicsItem::mouseMoveEvent(e);
}