#pragma once
#include <QStyle>
#include <QGraphicsItem>
#include <QGraphicsPathItem>
#include <QGraphicsSceneMouseEvent>
#include <QStyleOptionGraphicsItem>

class MyPathItem : public QGraphicsPathItem
{
protected:
	virtual void paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget) override;
};

class DicomItem : public QGraphicsItem
{
	//Q_OBJECT
	//Q_INTERFACES(QGraphicsItem)1
public:
	DicomItem(QPointF p, QGraphicsItem* parent = 0);
	~DicomItem(); 

	QPointF getPoint() { return m_point; }
	void setPoint(QPointF p) { m_point = p; }

protected:
	virtual QRectF boundingRect() const override;
	virtual void paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget) override;
	virtual void mouseMoveEvent(QGraphicsSceneMouseEvent *e);

private:
	QPointF m_point;
};
