#pragma once

#include <QGraphicsScene>
#include <QPainterPath>
#include <QGraphicsPathItem>
#include <QtWidgets/QPushButton>
#include <QObject>
#include "DicomItem.h"
#include "DicomTexItem.h"
#include "myGobal.h"

class DicomScene : public  QGraphicsScene
{
	Q_OBJECT

public:
	DicomScene(QObject *parent = 0);
	~DicomScene();
	void DelItems();
	void setBtn();

	QPushButton *pBtn = 0; 
	QList<MyPathItem*> m_itemList;
private:
	void BeginDraw(QPointF beginPos, QPointF nextPos, int type);
	void MovingDraw(QPointF beginPos, QPointF movingPos, int type);
	void PressDraw(QPointF beginPos, QPointF pressPos, int type);
	void EndDraw(QPointF beginPos, QPointF endgPos, int type);

public slots:
	void OnDrawImage(QPointF beginPos, QPointF nextPos, int type, int state);

protected:
	void mouseMoveEvent(QGraphicsSceneMouseEvent *mouseEvent);

private:
	MyPathItem *m_currentItem;
	QVector<QPointF> m_polygonVec;
	QVector<QPointF> m_bezierVec;	
};
