#include "DicomTexItem.h"

#include <QFont>
#include <QPainter>
#include <QCursor>
#include <QKeyEvent>
#include <QGraphicsSceneHoverEvent>
#include <QGraphicsSceneContextMenuEvent>
#include <QMenu>

DicomTexItem::DicomTexItem(QPointF beginPos, QGraphicsItem *parent) :
	QGraphicsItem(parent)
{
	setFlag(QGraphicsItem::ItemIsFocusable);
	setFlag(QGraphicsItem::ItemIsMovable);

	//
	QFont font = QFont("SimSun", 11);//font.setPointSize(12);
	//ߴ
	text_width = 300;
	adjust = 5;
	ax = beginPos.x();
	ay = beginPos.y();
	//ı
	text_item = new QGraphicsTextItem(this); 
	text_item->setDefaultTextColor(Qt::yellow);//Ĭıɫ
	text_item->setTextWidth(text_width);
	text_item->setFont(font);
	text_item->setTextInteractionFlags(Qt::TextEditorInteraction);
	text_interaction = true;
	//text_item->setPlainText(QString::fromLocal8Bit("һֵ֡Ŀ150ʱỻС"));
	text_rect = text_item->boundingRect();
	//text_item->setPos(ax, ay);
    //ο11
	rect_item = new QGraphicsRectItem(this);
	//rect_item->setBrush(Qt::blue);
	rect_item ->setPen(QPen(QBrush(Qt::blue), 2, Qt::SolidLine));
	setRect();
}

DicomTexItem::~DicomTexItem()
{
	delete text_item;
	delete rect_item;
}

void DicomTexItem::setRect()
{
	adjust = 0;
	rect_item->setRect(ax, ay, text_rect.width() + adjust, text_rect.height() + adjust);
	text_item->setPos(ax, ay);
}

QRectF DicomTexItem::boundingRect(void) const
{
	//rect_item->setRect(ax, ay, text_rect.width() + 7,text_rect.height() + 7);
	return rect_item->boundingRect();
}

void DicomTexItem::paint(QPainter *painter,	const QStyleOptionGraphicsItem *option,QWidget *widget)
{
	reset_text_rect();
	setRect();
	update(); //ÿα༭궼
	//QGraphicsItem::paint(painter, option, widget);
}

void DicomTexItem::keyPressEvent(QKeyEvent *event)
{
	QGraphicsItem::keyPressEvent(event);
}

void DicomTexItem::mousePressEvent(QGraphicsSceneMouseEvent *event)
{
	setFocus();
	QGraphicsItem::mousePressEvent(event);
}

void DicomTexItem::hoverEnterEvent(QGraphicsSceneHoverEvent *event)
{
	setCursor(Qt::OpenHandCursor);
}

void DicomTexItem::hoverLeaveEvent(QGraphicsSceneHoverEvent *event)
{
	setCursor(Qt::ArrowCursor);
}

void DicomTexItem::mouseMoveEvent(QGraphicsSceneMouseEvent *event)
{
	setCursor(Qt::IBeamCursor);
	QGraphicsItem::mouseMoveEvent(event);
}

void DicomTexItem::mouseReleaseEvent(QGraphicsSceneMouseEvent * event)
{
	setCursor(Qt::ArrowCursor);
	QGraphicsItem::mouseReleaseEvent(event);
}

/*void DicomTexItem::contextMenuEvent(QGraphicsSceneContextMenuEvent *event)
{
	QMenu menu;
	QAction *edit_action = menu.addAction("༭");
	QAction *selected_action = menu.exec(event->screenPos());
	if (selected_action == edit_action) {
		if (text_interaction) {
			text_item->setTextInteractionFlags(Qt::NoTextInteraction);
			text_interaction = false;
			reset_text_rect();
			update(); //ÿα༭궼
		}
		else {
			text_item->setTextInteractionFlags(Qt::TextEditorInteraction);
			text_interaction = true;
		}
	}
}*/

void DicomTexItem::reset_text_rect(void)
{
	text_rect = text_item->boundingRect();
}