#include "DicomText.h"
#include <QThread>
#include <QSettings>
#include <QFileDialog>
#include <QMessageBox>
#include <QDragEnterEvent>
#include <QFile>
#include <QDebug>
#include <QMimeData>
#include <QDir>
#include <QFileInfoList>
#include <QDirIterator>
#include <QCursor>
#include <QPoint>
#include <QMenu>
#include <QListWidgetItem>

#include "ReadWorker.h"
#include "SeriesBase.h"
#include "XYSeries.h"
#include "XZSeries.h"	
#include "YZSeries.h"
#include "Image.h"

using namespace std;

int seriesCount = 0;
QFileInfoList fileInfoList;
QStringList DirList;
QString mPath = "", tmp = "", m3Dparh = "";
QString m_id = "",strMPR = "MPR ؽ";
bool isShow = false, isXY = false, isPlay = false;
ReadWorker *worker = NULL;
QFont boldFont;
SeriesBase *mDicoms;

QFileInfoList GetAllDir(QString DirName)
{
	QFileInfoList DirList;

	/*ù˲QDir::NoDotAndDotDotʾȥϲĿ¼*/
	QDirIterator dir_iterator(DirName, /*QDir::Files |*/ QDir::Dirs | QDir::NoDotAndDotDot, QDirIterator::Subdirectories);
	while (dir_iterator.hasNext())
	{
		dir_iterator.next();	
	}
	return DirList;
}

bool isDCM(QString FileName)
{
	// isGetImg = false;
	bool mis = true;
	Image *dicom = new Image(FileName);
	if (!dicom->isNormal())
	{
		mis = false;
	}
	delete dicom;
	return mis;
}

void DicomText::fileTraverse(QString path)
{
	QString filter = "", fn = "";
	QDir dir(path);
	if (!dir.exists())
	{
		return;
	}
	dir.setFilter(QDir::Dirs | QDir::Files | QDir::NoDotAndDotDot | QDir::Hidden);
	dir.setSorting(QDir::DirsFirst);    //ļ
	QFileInfoList list = dir.entryInfoList();

	for (int i = 0; i < list.size(); i++)
	{
		QFileInfo fileInfo = list.at(i);
		if (fileInfo.isFile())
		{
			//do what you wanna do
			mPath = fileInfo.absolutePath();
			//filter = fileInfo.suffix();
			if (DirList.indexOf(mPath) == -1)
			{
				fn = fileInfo.absoluteFilePath();
				if (isDCM(fn) == true /*&& DirList.indexOf(mPath) == -1*/)
				{
					DirList.append(mPath);

					QStandardItem *item = new QStandardItem(mPath);
					model->appendRow(item);
					ui.listView_Dir->setModel(model);
					//delete item;*/
				}
			}
		}
		else
		{
			//do what you wanna do
			fileTraverse(fileInfo.filePath());
		}
	}
}

void DicomText::setStatus(viewStatus mStatus)
{
	switch (vtStatus)
	{
	case SeriesBase::XY:
		ui.graphicsView_XY->status = mStatus;
		ui.graphicsView_XZ->status = xzStatus;
		ui.graphicsView_YZ->status = yzStatus;
		break;
	case SeriesBase::XZ:
		ui.graphicsView_XY->status = xyStatus;
		ui.graphicsView_XZ->status = mStatus;
		ui.graphicsView_YZ->status = yzStatus;
		break;
	case SeriesBase::YZ:
		ui.graphicsView_XY->status = xyStatus;
		ui.graphicsView_XZ->status = xzStatus;
		ui.graphicsView_YZ->status = mStatus;
		break;
	default:
		break;
	}
}

void DicomText::getStatus()
{
	switch (vtStatus)
	{
	case SeriesBase::XY:currentStatus = ui.graphicsView_XY->status;	break;
	case SeriesBase::XZ:currentStatus = ui.graphicsView_XZ->status; break;
	case SeriesBase::YZ:currentStatus = ui.graphicsView_YZ->status; break;
	default:
		break;
	}
}

void DicomText::setMark(bool isBtn, MarkType mMark, SceneState mSceneState, QPushButton *pBtn)
{
	switch (vtStatus)
	{
	case SeriesBase::XY:
		ui.graphicsView_XY->isBtn = isBtn;
		ui.graphicsView_XY->Mark = mMark;
		ui.graphicsView_XY->mSceneState = mSceneState;
		ui.graphicsView_XY->pDVBtn = pBtn;
	    break;
	case SeriesBase::XZ:		
		ui.graphicsView_XZ->isBtn = isBtn;
		ui.graphicsView_XZ->Mark = mMark; 
		ui.graphicsView_XZ->mSceneState = mSceneState;
		ui.graphicsView_XZ->pDVBtn = pBtn;
		break;
	case SeriesBase::YZ:
		ui.graphicsView_YZ->isBtn = isBtn;
		ui.graphicsView_YZ->Mark = mMark; 
		ui.graphicsView_YZ->mSceneState = mSceneState;	
		ui.graphicsView_YZ->pDVBtn = pBtn;
		break;
	default:
		break;
	}
}

void DicomText::setZom(bool isyes)
{
	switch (vtStatus)
	{
	case SeriesBase::XY:
		ui.graphicsView_XY->isZom = isyes;
		ui.graphicsView_XZ->isZom = false;
		ui.graphicsView_YZ->isZom = false;
		break;
	case SeriesBase::XZ:
		ui.graphicsView_XY->isZom = false;
		ui.graphicsView_XZ->isZom = isyes;
		ui.graphicsView_YZ->isZom = false;
		break;
	case SeriesBase::YZ:
		ui.graphicsView_XY->isZom = false;
		ui.graphicsView_XZ->isZom = false;
		ui.graphicsView_YZ->isZom = isyes;
		break;
	default:
 		break;
	}
}

void DicomText::OpenDataDlg()
{
	int CurFrame, FrameCount; QPixmap mPix;
	QString CurFrameName, mtv;
	getFrame(CurFrameName, mPix, mtv);
	Qt::WindowFlags flags = Qt::Dialog; flags |= Qt::WindowCloseButtonHint;
	mDcmDataDlg = new DcmDataDlg(this);
	mDcmDataDlg->setWindowFlags(flags);
	//connect(loginDlg, SIGNAL(getSoftwareMode(QString)), this, SLOT(setSoftwareModeSlot(QString)));
	mDcmDataDlg->setWindowTitle(QString::fromLocal8Bit("ǩϢ"));
	mDcmDataDlg->setText(CurFrameName);
	mDcmDataDlg->setWindowModality(Qt::ApplicationModal);
	mDcmDataDlg->show();
}

void DicomText::updateView()
{
	double ww = 0.0, wl = 0.0;
	SeriesBase::getWindow(wl, ww);
	ui.graphicsView_XY->updateView();
	ui.graphicsView_YZ->updateView();
	ui.graphicsView_XZ->updateView(); 
}

void DicomText::getFrame(QString & mCurFrameName, QPixmap & mPixmap, /*int & mCurFrame, int & mFrameCount,*/QString & MtV)
{
	switch (vtStatus)
	{
	case SeriesBase::XY:
		MtV = "XY-";
		mDicoms = xyS;
		mCurFrameName = ui.graphicsView_XY->CurFrameName;
		mPixmap = ui.graphicsView_XY->mPixmap;
		break;
	case SeriesBase::XZ:
		MtV = "XZ-";
		mDicoms = xzS;
		mCurFrameName = ui.graphicsView_XZ->CurFrameName;
		mPixmap = ui.graphicsView_XZ->mPixmap;
		break;
	case SeriesBase::YZ:
		MtV = "YZ-";
		mDicoms = yzS;
		mCurFrameName = ui.graphicsView_YZ->CurFrameName;
		mPixmap = ui.graphicsView_YZ->mPixmap;
		break;
	default:
		break;
	}
}

void DicomText::setPlayBtn()
{
	if (ui.graphicsView_XY->CurFrame == ui.graphicsView_XY->FrameCount)
	{
		ui.graphicsView_XY->isPlay = false;
		ui.graphicsView_XY->setCurFrameItem(ui.graphicsView_XY->FrameCount / 2);
		ui.graphicsView_XY->playindex = 0;
	}
	if (ui.graphicsView_XZ->CurFrame == ui.graphicsView_XZ->FrameCount)
	{
		ui.graphicsView_XZ->isPlay = false;
		ui.graphicsView_XZ->setCurFrameItem(ui.graphicsView_XZ->FrameCount / 2);
		ui.graphicsView_XZ->playindex = 0;
	}
	if (ui.graphicsView_YZ->CurFrame == ui.graphicsView_YZ->FrameCount)
	{
		ui.graphicsView_YZ->isPlay = false;
		ui.graphicsView_YZ->setCurFrameItem(ui.graphicsView_YZ->FrameCount / 2);
		ui.graphicsView_YZ->playindex = 0;
	}
}

void DicomText::MarkSaveFile(QPixmap mPix)
{
	QString fileName = QFileDialog::getSaveFileName(this, tr("Save File"), "", tr("Images (*.png *.bmp *.jpg)"));

	if (!fileName.isNull())
	{
		//fileNameļ 
		if (mPix.save(fileName) == true)
		{
			QMessageBox::information(this, QString::fromLocal8Bit("ʾ"), QString::fromLocal8Bit("ıɹ."));
		}
	}
	else
	{
		//ȡ
	}
}

void DicomText::setBtnMenu(QPushButton * pBtn)
{
	menu = new QMenu(pBtn);

	QAction *action1 = new QAction(QStringLiteral("Ĭ"), menu);
	QAction *action2 = new QAction(QStringLiteral("ͷ"), menu);
	QAction *action3 = new QAction(QStringLiteral(""), menu);
	QAction *action4 = new QAction(QStringLiteral("ݸ"), menu);
	QAction *action5 = new QAction(QStringLiteral(""), menu);
	QAction *action6 = new QAction(QStringLiteral(""), menu);
	QAction *action7 = new QAction(QStringLiteral("ֶ"), menu);

	menu->addAction(action1);
	menu->addSeparator();
	menu->addAction(action2);
	menu->addAction(action3);
	menu->addAction(action4);
	menu->addAction(action5);
	menu->addAction(action6);
	menu->addSeparator();
	menu->addAction(action7);
	actionList = menu->actions();
	pBtn->setMenu(menu);

	connect(action1, SIGNAL(triggered(bool)), this, SLOT(textChanged1(bool)));
	connect(action2, SIGNAL(triggered(bool)), this, SLOT(textChanged2(bool)));
	connect(action3, SIGNAL(triggered(bool)), this, SLOT(textChanged3(bool)));
	connect(action4, SIGNAL(triggered(bool)), this, SLOT(textChanged4(bool)));
	connect(action5, SIGNAL(triggered(bool)), this, SLOT(textChanged5(bool)));
	connect(action6, SIGNAL(triggered(bool)), this, SLOT(textChanged6(bool)));
	connect(action7, SIGNAL(triggered(bool)), this, SLOT(textChanged7(bool)));
}

void DicomText::setBtnMenu2(QPushButton * pBtn)
{
	menu2 = new QMenu(pBtn);

	QAction *action1 = new QAction(QStringLiteral("Ĭֵ"), menu2);
	QAction *action2 = new QAction(QStringLiteral(" 5mm"), menu2);
	QAction *action3 = new QAction(QStringLiteral("10mm"), menu2);
	QAction *action4 = new QAction(QStringLiteral("15mm"), menu2);
	QAction *action5 = new QAction(QStringLiteral("20mm"), menu2);

	menu2->addAction(action1);
	menu2->addSeparator();
	menu2->addAction(action2);
	menu2->addAction(action3);
	menu2->addAction(action4);
	menu2->addAction(action5);
	actionList2 = menu2->actions();
	pBtn->setMenu(menu2);
}

void DicomText::setBtnMenuCheckad(int id)
{
	ui.graphicsView_XY->isPrevMouse = false;
	ui.graphicsView_YZ->isPrevMouse = false;
	ui.graphicsView_XZ->isPrevMouse = false;

	for (int i = 0; i < actionList.size(); i++)
	{
		if (i == id)
		{
			actionList[i]->setCheckable(true);
			actionList[i]->setChecked(true);
			if (id == 8)
			{
				ui.graphicsView_XY->isPrevMouse = true;
				ui.graphicsView_YZ->isPrevMouse = true;
				ui.graphicsView_XZ->isPrevMouse = true;
			}
		}
		else
		{
			actionList[i]->setCheckable(FALSE);
			actionList[i]->setChecked(false);
		}
	}
}

void DicomText::setBtnMenuCheckad2(int id)
{
	for (int i = 0; i < actionList2.size(); i++)
	{
		if (i == id)
		{
			actionList2[i]->setCheckable(true);
			actionList2[i]->setChecked(true);			
		}
		else
		{
			actionList2[i]->setCheckable(FALSE);
			actionList2[i]->setChecked(false);
		}
	}
}

void DicomText::fun_1()
{
	//on_pushButton_8_clicked();
}

void DicomText::showClick(QModelIndex index)
{
	if (isShow == false)
	{
		QString dirStr = index.data().toString();
		if (tmp != dirStr)
		{
			tmp = dirStr;
			m3Dparh = dirStr;
			GetDir(dirStr);
		}
	}
}

void DicomText::showContextmenu1(const QPoint & pos)
{
	//հ״ֲ˵
	try
	{
		if (DirList.size() > 0)
		{
			if (!(ui.listView_Dir->selectionModel()->selectedIndexes()).empty())
			{

				qDebug() << "show_contextmenu1";
				QMenu *cmenu = new QMenu(ui.listView_Dir);
				QAction *DelSelectionModel = cmenu->addAction(QString::fromLocal8Bit("ɾ"));
				//QAction *descendSortAction = cmenu->addAction("");
				//QAction *filterAction = cmenu->addAction("");
				//QAction *reshowAction = cmenu->addAction("");
				connect(DelSelectionModel, SIGNAL(triggered(bool)), this, SLOT(edit_menu_del()));
				//connect(descendSortAction, SIGNAL(triggered(bool)), this, SLOT(edit_menu2()));
				//connect(filterAction, SIGNAL(triggered(bool)), this, SLOT(edit_menu3()));
				//connect(reshowAction, SIGNAL(triggered(bool)), this, SLOT(edit_menu4()));
				cmenu->exec(QCursor::pos());//ڵǰλʾ
				//cmenu->exec(pos)viewportʾ
				
				//ѡе
				//i.listView_Dir->selectionModel()->clear();
			}
		}
	}
	catch (...)
	{
		//return false;
	}
}

void DicomText::edit_menu_del()
{
	QMessageBox::information(this, QString::fromLocal8Bit("ʾ"), QString::fromLocal8Bit("ڴing"));
}

void DicomText::textChanged1(bool yes)
{
	if (isXY)
	{
		setBtnMenuCheckad(0);
		SeriesBase::setWindow(winWidth, winCenter);
		ui.graphicsView_XY->updateView();
		ui.graphicsView_YZ->updateView();
		ui.graphicsView_XZ->updateView();
	}
}

void DicomText::textChanged2(bool yes)
{
	if (isXY)
	{
		setBtnMenuCheckad(2);
		win_Ws = 80.0; win_Ls = 40.0;
		SeriesBase::setWindow(win_Ls, win_Ws);
		ui.graphicsView_XY->updateView();
		ui.graphicsView_YZ->updateView();
		ui.graphicsView_XZ->updateView();
	}
}

void DicomText::textChanged3(bool yes)
{
	if (isXY)
	{
		setBtnMenuCheckad(3);
		win_Ws = 1500.0; win_Ls = -400.0;
		SeriesBase::setWindow(win_Ls, win_Ws);
		ui.graphicsView_XY->updateView();
		ui.graphicsView_YZ->updateView();
		ui.graphicsView_XZ->updateView();
	}
}

void DicomText::textChanged4(bool yes)
{
	if (isXY)
	{
		setBtnMenuCheckad(4);
		win_Ws = 400.0; win_Ls = 60.0;
		SeriesBase::setWindow(win_Ls, win_Ws);
		ui.graphicsView_XY->updateView();
		ui.graphicsView_YZ->updateView();
		ui.graphicsView_XZ->updateView();
	}
}

void DicomText::textChanged5(bool yes)
{
	if (isXY)
	{
		setBtnMenuCheckad(5);
		win_Ws = 400.0; win_Ls = 40.0;
		SeriesBase::setWindow(win_Ls, win_Ws);
		ui.graphicsView_XY->updateView();
		ui.graphicsView_YZ->updateView();
		ui.graphicsView_XZ->updateView();
	}
}

void DicomText::textChanged6(bool yes)
{
	if (isXY)
	{
		setBtnMenuCheckad(6);
		win_Ws = 1500.0; win_Ls = 300.0;
		SeriesBase::setWindow(win_Ls, win_Ws);
		ui.graphicsView_XY->updateView();
		ui.graphicsView_YZ->updateView();
		ui.graphicsView_XZ->updateView();
	}
}

void DicomText::textChanged7(bool yes)
{
}

void DicomText::receiveData(QString data)
{
	DirExport = data;     //ȡݹ
}

DicomText::DicomText(QWidget *parent)
	: QMainWindow(parent)
{
	ui.setupUi(this); 
	this->setAcceptDrops(true);
	ui.textBrowser->setStyleSheet("background-color: rgb(0, 0, 0);");
	isOpeing = false;	
	Rad_G::m_mainWin = this;
	
	DirList.clear();
	ui.listView_Dir->setContextMenuPolicy(Qt::CustomContextMenu); 
	//ui.pushButton_MPR->setText(QString::fromLocal8Bit("MPR ؽ"));

	connect(ui.graphicsView_XY, SIGNAL(windowChanged()), this, SLOT(on_windowChanged()));
	connect(ui.graphicsView_XZ, SIGNAL(windowChanged()), this, SLOT(on_windowChanged()));
	connect(ui.graphicsView_YZ, SIGNAL(windowChanged()), this, SLOT(on_windowChanged()));

	connect(ui.graphicsView_XY, SIGNAL(clicked(SeriesBase::ViewType)), this, SLOT(on_clickedView(SeriesBase::ViewType)));
	connect(ui.graphicsView_XZ, SIGNAL(clicked(SeriesBase::ViewType)), this, SLOT(on_clickedView(SeriesBase::ViewType)));
	connect(ui.graphicsView_YZ, SIGNAL(clicked(SeriesBase::ViewType)), this, SLOT(on_clickedView(SeriesBase::ViewType)));

    connect(ui.listView_Dir, SIGNAL(clicked(QModelIndex)), this, SLOT(showClick(QModelIndex)));
	connect(ui.listView_Dir, SIGNAL(customContextMenuRequested(const QPoint&)),	this, SLOT(showContextmenu1(const QPoint&)));
	
	ui.graphicsView_XY->setHighlight(true);
	vtStatus = SeriesBase::XY;

	defaultStatus = Browse;
	xyStatus = ui.graphicsView_XY->status;
	xzStatus = ui.graphicsView_XZ->status;
	yzStatus = ui.graphicsView_YZ->status;

	ui.graphicsView_XY->msl = "R";
	ui.graphicsView_XY->mst = "A";
	ui.graphicsView_XY->msr = "L";
	ui.graphicsView_XY->msb = "P";

	ui.graphicsView_XZ->msl = "R";
	ui.graphicsView_XZ->mst = "S";
	ui.graphicsView_XZ->msr = "L";
	ui.graphicsView_XZ->msb = "I";
	
	ui.graphicsView_YZ->msl = "A";
	ui.graphicsView_YZ->mst = "S";
	ui.graphicsView_YZ->msr = "P";
	ui.graphicsView_YZ->msb = "I";

	ui.graphicsView_XY->setVisible(false);
	ui.graphicsView_XZ->setVisible(false);
	ui.graphicsView_YZ->setVisible(false);
	
	ui.label_7->setVisible(false);
	ui.label_8->setVisible(false);
	ui.label_9->setVisible(false);
	ui.lineEdit->setVisible(false);
	ui.lineEdit_2->setVisible(false);
	ui.lineEdit_3->setVisible(false);
	ui.textBrowser->setVisible(true);

	ui.lineEdit->setContextMenuPolicy(Qt::NoContextMenu);
	ui.lineEdit_2->setContextMenuPolicy(Qt::NoContextMenu);
	ui.lineEdit_3->setContextMenuPolicy(Qt::NoContextMenu);
	ui.textBrowser->setContextMenuPolicy(Qt::NoContextMenu);
	
	ui.lineEdit->setFocusPolicy(Qt::NoFocus);
	ui.lineEdit_2->setFocusPolicy(Qt::NoFocus);
	ui.lineEdit_3->setFocusPolicy(Qt::NoFocus);
	ui.lineEdit_uid->setFocusPolicy(Qt::NoFocus);

	ui.comboBox_3->addItem(QString::fromLocal8Bit(""));
	ui.comboBox_3->addItem(QString::fromLocal8Bit("״"));
	ui.comboBox_3->addItem(QString::fromLocal8Bit("ʸ״"));
	ui.comboBox_3->addItem(QString::fromLocal8Bit(""));

	setBtnMenu(ui.pushButton_11);
	setBtnMenu2(ui.pushButton_2);

	model = new QStandardItemModel(this); //԰зŵͷļ=
	xyS = new XYSeries();
	xzS = new XZSeries();
	yzS = new YZSeries();
}

DicomText::~DicomText()
{
	if (menu != 0)
	{
		delete menu;
	}
	delete model;
	delete xyS;
	delete xzS;
	delete yzS;
}

void DicomText::GetDir(QString mStr)
{
	QString m_dir = mStr;
	if (isOpeing)
	{
		QMessageBox::warning(this, QString::fromLocal8Bit("ʾ"), QStringLiteral("ڼݣȴɴݣ"));
		return;
	}

	isOpeing = true; 
	isShow = true;
	isXY = false;
	ui.comboBox_2->clear();
	ui.lineEdit_uid->setText(m_dir);
	ui.lineEdit->setText("");
	ui.lineEdit_2->setText("");
	ui.lineEdit_3->setText("");	
	ui.textBrowser->setVisible(true);
	ui.graphicsView_XY->setVisible(false); 
	ui.graphicsView_XZ->setVisible(false);
	ui.graphicsView_YZ->setVisible(false);
	ui.graphicsView_XY->close();
	ui.graphicsView_YZ->close();
	ui.graphicsView_XZ->close(); 
	//strMPR = "MPR ؽ";
	//ui.pushButton_MPR->setText(QString::fromLocal8Bit("MPR ؽ"));
	ui.comboBox_3->setCurrentIndex(0);
	//ReadWorker *
	worker = new ReadWorker(m_dir);

	QThread *thread = new QThread();
	connect(thread, SIGNAL(started()), worker, SLOT(checkDicomsFileDir())); // ߳̿ʼִworker->checkDicomsFileDir()
	connect(worker, SIGNAL(progress(int)), this, SLOT(setProgressBarValue(int)));// worker źţִthis->setProgressBarValue
	connect(worker, SIGNAL(finish()), this, SLOT(ReadCheckCompleted()));// ɣִthis->ReadCheckCompleted()
	connect(worker, SIGNAL(finish()), worker, SLOT(deleteLater()));// ִɣworker
	connect(worker, SIGNAL(destroyed(QObject*)), thread, SLOT(quit()));// worker ɣ Ƴ߳
	connect(thread, SIGNAL(finished()), thread, SLOT(deleteLater())); // Ƴ̣߳ ߳
	worker->moveToThread(thread); // worker ƶ߳
	thread->start(); // ʼ߳

	//delete worker;
}

void DicomText::RCompleted(QString seriesUID)
{
	isOpeing = true;
	SeriesBase::readSeriesUid(seriesUID);
	isOpeing = false;
	if (!SeriesBase::isNormal())
		return;
	
	int w, h, s;
	SeriesBase::getSeriesSize(w, h, s);
	SeriesBase::getWindow(winWidth, winCenter);
	
	setBtnMenuCheckad(0);
	ui.lineEdit->setText(QString("%1").arg(w));
	ui.lineEdit_2->setText(QString("%1").arg(h));	
	ui.lineEdit_3->setText(QString("%1").arg(s));
	
	xyS->update(); 
	xzS->update(); 
	yzS->update();
	
	isXY = true;
	isPlay = false;

	/*boldFont.setBold(false);//Ӵ
	ui.pushButton_10->setFont(boldFont);
	ui.pushButton_10->setText(QString::fromLocal8Bit("Զ"));
	*/
	ui.textBrowser->setVisible(false);
	ui.graphicsView_XY->setVisible(true);
	ui.graphicsView_XZ->setVisible(false);
	ui.graphicsView_YZ->setVisible(false);
	ui.graphicsView_XY->setSeries(xyS);
	ui.graphicsView_YZ->setSeries(yzS);
	ui.graphicsView_XZ->setSeries(xzS);

	isShow = false; // delete worker;
	worker = NULL;

}

void DicomText::dragEnterEvent(QDragEnterEvent * e)
{
	//Ϸ¼ɸѡ
	if (true)
	{
		e->acceptProposedAction();	//У򲻻ִdropEvent()
	}
}

void DicomText::dropEvent(QDropEvent * e)
{
	QString tmp = e->mimeData()->text();
	int pos = tmp.lastIndexOf(":");
	QString dirStr = tmp.mid(pos - 1);
	if (dirStr.isEmpty())
		return;
	fileTraverse(dirStr);
}

void DicomText::on_pushButton_clicked()
{
	//  "ѡDicomļ"ťִиú
	QSettings s; // Ϊ˼סһε·
	QString dirStr = s.value("OPEN_FILEPATH", ".").toString();// ڵĻΪǰӦó·
	dirStr = QFileDialog::getExistingDirectory(this, QStringLiteral("ѡDicomڵļ"), dirStr);

	if (dirStr.isEmpty())
		return;
	s.setValue("OPEN_FILEPATH", dirStr); // ס·Ա´ʹ

	fileTraverse(dirStr);
}

void  DicomText::on_comboBox_2_currentIndexChanged(QString seriesUID)
{
	isXY = false;
	ui.lineEdit->setText("");
	ui.lineEdit_2->setText("");
	ui.lineEdit_3->setText("");
	ui.textBrowser->setVisible(true);
	ui.graphicsView_XY->setVisible(false); 
	ui.graphicsView_XZ->setVisible(false);
	ui.graphicsView_YZ->setVisible(false);
	ui.graphicsView_XY->close();
	ui.graphicsView_YZ->close();
	ui.graphicsView_XZ->close();
//	strMPR = "MPR ؽ";
//	ui.pushButton_MPR->setText(QString::fromLocal8Bit("MPR ؽ"));
	ui.comboBox_3->setCurrentIndex(0);
	
	m_id = seriesUID;
//	m3Dparh = m3Dparh + "/" + m_id;
	RCompleted(m_id);
}

void DicomText::on_comboBox_3_currentIndexChanged(QString currentText)
{
	if (isXY)
	{
		setPlayBtn();

		if (currentText == QString::fromLocal8Bit(""))
		{
			ui.graphicsView_XY->setVisible(true);
			ui.graphicsView_XZ->setVisible(false);
			ui.graphicsView_YZ->setVisible(false);
			ui.graphicsView_XY->setHighlight(true);
			ui.graphicsView_XZ->setHighlight(false);
			ui.graphicsView_YZ->setHighlight(false);
			vtStatus = SeriesBase::XY;
			setStatus(defaultStatus);
			//return;
		}
		if (currentText == QString::fromLocal8Bit("״"))
		{
			ui.graphicsView_XY->setVisible(false);
			ui.graphicsView_XZ->setVisible(true);
			ui.graphicsView_YZ->setVisible(false); 
			ui.graphicsView_XY->setHighlight(false);
			ui.graphicsView_XZ->setHighlight(true);
			ui.graphicsView_YZ->setHighlight(false);
			setStatus(defaultStatus);
			vtStatus = SeriesBase::XZ;
			//return;
		}

		if (currentText == QString::fromLocal8Bit("ʸ״"))
		{
			ui.graphicsView_XY->setVisible(false);
			ui.graphicsView_XZ->setVisible(false);
			ui.graphicsView_YZ->setVisible(true);
			ui.graphicsView_XY->setHighlight(false);
			ui.graphicsView_XZ->setHighlight(false);
			ui.graphicsView_YZ->setHighlight(true);
			vtStatus = SeriesBase::YZ;
			setStatus(defaultStatus);
			//return;
		}

		if (currentText == QString::fromLocal8Bit(""))
		{
			ui.graphicsView_XY->setVisible(true);
			ui.graphicsView_XZ->setVisible(true);
			ui.graphicsView_YZ->setVisible(true);
			ui.graphicsView_XY->setHighlight(true);
			ui.graphicsView_XZ->setHighlight(false);
			ui.graphicsView_YZ->setHighlight(false);
			vtStatus = SeriesBase::XY;
			setStatus(defaultStatus);
			//return;
		}

		if (isSetStatus == false)
		{
			getStatus();
			setStatus(Pan);
		}
		if (isSetZom == false)
		{
			setZom(true);
		}
		//etStatus(defaultStatus);
	}
	else
	{
		ui.comboBox_3->setCurrentIndex(0);
	}
}

void DicomText::on_pushButton_12_clicked()
{
	if (isXY)
	{
		OpenDataDlg();
	}
}

void DicomText::on_comboBox_currentIndexChanged(int color)
{
	SeriesBase::setColor(color);
	ui.graphicsView_XY->updateView();
	ui.graphicsView_YZ->updateView();
	ui.graphicsView_XZ->updateView();
}

void DicomText::on_lineEdit_ww_textEdited(QString ww)
{
	double ww_d = 0.0, wl = 0.0;
	SeriesBase::getWindow(wl, ww_d);
	ww_d = ww.toDouble();
	SeriesBase::setWindow(wl, ww_d);
	ui.graphicsView_XY->updateView();
	ui.graphicsView_YZ->updateView();
	ui.graphicsView_XZ->updateView();
}

void DicomText::on_lineEdit_wl_textEdited(QString wl)
{
	double ww = 0.0, wl_d = 0.0;
	SeriesBase::getWindow(wl_d, ww);
	wl_d = wl.toDouble();
	SeriesBase::setWindow(wl_d, ww);
	ui.graphicsView_XY->updateView();
	ui.graphicsView_YZ->updateView();
	ui.graphicsView_XZ->updateView();
}

void DicomText::setProgressBarValue(int progress)
{
	ui.progressBar->setValue(progress);
}

void DicomText::setPixelInfo(QString pixelInfo)
{
//	ui.textBrowser->setText(pixelInfo);
}

void DicomText::setStatusMessage(QString message)
{
	ui.statusBar->showMessage(message, 2888);
}

void DicomText::on_windowChanged()
{
	updateView();
}

void DicomText::ReadCheckCompleted()
{	
	ui.comboBox_2->clear();
	foreach(QString uid, ReadWorker::UID_Files.keys())
	{
		ui.comboBox_2->addItem(uid);
	}
	isOpeing = false; 	
	ui.comboBox_3->setCurrentIndex(0);
	ui.lineEdit->setText("");
	ui.lineEdit_2->setText("");
	ui.lineEdit_3->setText("");

	on_comboBox_2_currentIndexChanged(ui.comboBox_2->currentText());
}

void DicomText::on_clickedView(SeriesBase::ViewType vt)
{
	vtStatus = vt;
	switch (vt)
	{
	case SeriesBase::XY:
		ui.graphicsView_XY->setHighlight(true);
		ui.graphicsView_XZ->setHighlight(false);
		ui.graphicsView_YZ->setHighlight(false);
		break;
	case SeriesBase::XZ:
		ui.graphicsView_XY->setHighlight(false);
		ui.graphicsView_XZ->setHighlight(true);
		ui.graphicsView_YZ->setHighlight(false);
		break;
	case SeriesBase::YZ:
		ui.graphicsView_XY->setHighlight(false);
		ui.graphicsView_XZ->setHighlight(false);
		ui.graphicsView_YZ->setHighlight(true);
		break;
	default:
		break;
	}	
}