#include "DicomView.h"

#include <QGraphicsPixmapItem>
#include <QGraphicsWidget>
#include <QGraphicsProxyWidget>
#include <QGraphicsLinearLayout>
#include <QMouseEvent>
#include <QMessageBox>
#include <QKeyEvent>
#include <QGraphicsscene>
#include <QDebug>
#include <QScrollBar>
#include <qslider.h>

double winWidth, winCenter, sliceThickness;
int w, h, s;
//
QString	patientID = "";
//
QString	patientName = "";
//
QDate  patientBirth;
//Ա
QString	patientSex = "";
//
QString	patientAge = "";

QString	patTxt;

#define VIEW_CENTER viewport()->rect().center()
#define VIEW_WIDTH  viewport()->rect().width()
#define VIEW_HEIGHT viewport()->rect().height()

//ԶQtʱ,λ
void mySleep_1(int msec)
{
	QTime dieTime = QTime::currentTime().addMSecs(msec);
	while (QTime::currentTime() < dieTime)
		QCoreApplication::processEvents(QEventLoop::AllEvents, 100);
}

void mySleep_2(int msec)
{
	QDateTime last = QDateTime::currentDateTime();
	QDateTime now;
	while (1)
	{
		now = QDateTime::currentDateTime();
		if (last.msecsTo(now) >= msec)
		{
			break;
		}
	}
}

DicomView::DicomView(QWidget *parent) : QGraphicsView(parent)//, ruler(new Ruler(this))
{
	//scene = new QGraphicsScene(this);
	scene = new DicomScene(this);
	pixmapItem = new QGraphicsPixmapItem;
	posValueItem = new QGraphicsSimpleTextItem;
	curFrameItem = new QGraphicsSimpleTextItem;
	_pWLValueItem = new QGraphicsSimpleTextItem;
	_pdicomsSizeItem = new QGraphicsSimpleTextItem;
	_patValItem = new QGraphicsSimpleTextItem;

	L_TextItem = new QGraphicsSimpleTextItem;
	T_TextItem = new QGraphicsSimpleTextItem;
	R_TextItem = new QGraphicsSimpleTextItem;
	B_TextItem = new QGraphicsSimpleTextItem;
	TmpItem = new QGraphicsTextItem;
	
	dicoms = 0;
	status = Browse;
	Mark = T_None;
	mSceneState = S_None;

	setFocusPolicy(Qt::StrongFocus);
	setHorizontalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
	setVerticalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
	setContextMenuPolicy(Qt::DefaultContextMenu);
	setBackgroundBrush(QBrush(Qt::black));
	setAcceptDrops(true);
	setFrameShape(QFrame::Box);
	setFrameShadow(QFrame::Plain);
	setAlignment(Qt::AlignCenter);
	setResizeAnchor(QGraphicsView::AnchorViewCenter);
	//setAlignment(Qt::AlignLeft | Qt::AlignTop);
	//setCursor(Qt::PointingHandCursor);
	
	setHighlight(false);

	scene->setSceneRect(-5000, -5000, 10000, 10000);
	setScene(scene);

	// ͼƬл
	pixmapItem->setTransformationMode(Qt::SmoothTransformation);
	pixmapItem->setAcceptHoverEvents(true);
	posValueItem->setBrush(Qt::yellow/*white/*magenta*/);
	curFrameItem->setBrush(Qt::yellow/*magenta*/);

	_pWLValueItem->setBrush(Qt::yellow);
	_pdicomsSizeItem->setBrush(Qt::yellow);
	_patValItem->setBrush(Qt::yellow);

	L_TextItem->setBrush(Qt::yellow);
	T_TextItem->setBrush(Qt::yellow);
	R_TextItem->setBrush(Qt::yellow);
	B_TextItem->setBrush(Qt::yellow);

	TmpItem->setDefaultTextColor(Qt::yellow);
	//TmpItem->setPlainText("QGraphicsTextItem Engine ");
	
	scene->addItem(pixmapItem);
	scene->addItem(posValueItem);
	scene->addItem(curFrameItem);
	scene->addItem(_pWLValueItem); 
	scene->addItem(_pdicomsSizeItem);
	scene->addItem(_patValItem);

	scene->addItem(L_TextItem);
	scene->addItem(T_TextItem);
	scene->addItem(R_TextItem);
	scene->addItem(B_TextItem);
	scene->addItem(TmpItem);

	slider = new QGraphicsWidget;
	QGraphicsLinearLayout *verticalLayout = new QGraphicsLinearLayout;
	verticalLayout->setOrientation(Qt::Vertical);
	verticalLayout->setSpacing(0);
	slider->setLayout(verticalLayout);
	scene->addItem(slider); 
	
	connect(this, &DicomView::drawImage, scene, &DicomScene::OnDrawImage);
	//connect(ruler, &Ruler::sizeChanged, [this](QSize const& size) { setViewportMargins(size.width(), size.width(), 0, 0); });
}

DicomView::~DicomView()
{
	delete pixmapItem;
	delete posValueItem;
	delete curFrameItem;
	delete _pdicomsSizeItem;
	delete _pWLValueItem;
	delete _patValItem;
	delete L_TextItem;
	delete T_TextItem;
	delete R_TextItem;
	delete B_TextItem;
	delete TmpItem;
	delete scene;
}

void DicomView::setSeries(SeriesBase * series)
{
	if (!series)
		return;
	if (!series->isNormal())
		return;
	if (dicoms == 0)
	{
		// dicoms->slider ӵ slider
		QGraphicsProxyWidget*pw = scene->addWidget(series->slider);
		QGraphicsLinearLayout *verticalLayout = (QGraphicsLinearLayout *)slider->layout();
		verticalLayout->addItem(pw);
	}

	this->dicoms = series;
	dicoms->setDefaultWindow();
	emit windowChanged();
	connect(dicoms->slider, SIGNAL(valueChanged(int)), this, SLOT(setCurFrameItem(int)));
	dicoms->gotoFrame(dicoms->getFrameCount() / 2);

	double xSpacing = 0, ySpacing = 0;
	if (dicoms->getPixSpacing(xSpacing, ySpacing)) {
		if (xSpacing > 0.000001 && ySpacing > 0.000001) {
			double psX = xSpacing;
			double psY = ySpacing;
			fixFactor = psY / psX;
		}
	}
	
	SetItemTexr(); 
	
	isPlay = false;
	playindex = 0;
	pixmapItem->setPos(0, 0);
	pixmapItem->setRotation(0);
	pixmapItem->resetTransform();

	updateView();
	
	scene->update(scene->sceneRect());
}

void DicomView::resizePixmapItem()
{
	if (!pixmapItem->pixmap().isNull())
	{
		QRectF pixmapRect = pixmapItem->boundingRect();
		QRectF viewRect = this->rect();

		if (pixmapRect.width()*viewRect.height() < pixmapRect.height()*fixFactor*viewRect.width())
			factor = viewRect.height() / (pixmapRect.height()*fixFactor);
		else
			factor = viewRect.width() / pixmapRect.width();
		pixmapItem->setTransform(QTransform(factor, 0, 0, factor*fixFactor, 0, 0));
		centerOn(pixmapItem);
		getScale();
	}
}

void DicomView::repositionAuxItems()
{
	QPointF sceneTL = mapToScene(rect().topLeft());
	QPointF sceneBR = mapToScene(rect().bottomRight());

	/*T_TextItem->setPos(sceneBR.y()/2, sceneTL.y());
	L_TextItem->setPos(sceneTL.x(), sceneBR.y()/2);
	R_TextItem->setPos(sceneBR.x()-10, sceneBR.y()/2);
	B_TextItem->setPos(sceneBR.y()/2, sceneBR.y()-10);
	*/

	T_TextItem->setPos((sceneTL.x() + sceneBR.x()) / 2, sceneTL.y());
	L_TextItem->setPos(sceneTL.x(), (sceneBR.y() + sceneTL.y()) / 2);
	R_TextItem->setPos(sceneBR.x() - 10, (sceneBR.y() + sceneTL.y()) / 2);
	B_TextItem->setPos((sceneTL.x() + sceneBR.x()) / 2, sceneBR.y() - 15);

	TmpItem->setPos((sceneTL.x() + sceneBR.x()) / 2, sceneTL.y());
		
	_patValItem->setPos(sceneTL.x()+20, sceneTL.y()+20);
	curFrameItem->setPos(sceneBR.x()-170, sceneTL.y()+20);
	_pdicomsSizeItem->setPos(sceneBR.x() - 170, sceneTL.y() + 35);
	
	slider->setPos(sceneBR.x() - 58, sceneTL.y() + 58);

	QSizeF slider_size(58, sceneBR.y() - sceneTL.y() - 116);
	slider->resize(slider_size);
	posValueItem->setPos(sceneTL.x() + 20, sceneBR.y()- 50);
	_pWLValueItem->setPos(sceneTL.x() + 20, sceneBR.y() - 38);
}

void DicomView::updateView()
{
	QPixmap pixmap;
	if (dicoms && dicoms->isNormal()) 
	{
		dicoms->getPixmap(pixmap);
		pixmapItem->setPixmap(pixmap);
		pixmapItem->setTransformOriginPoint(pixmapItem->boundingRect().center()); 
		//if (isPlay == false) dicoms->gotoFrame(dicoms->getFrameCount() / 2);
		SetItemTexr();		
	}
	else
	{
		pixmapItem->setPixmap(pixmap); 
		curFrameItem->setText("");
		posValueItem->setText("");
		_pdicomsSizeItem->setText(""); 
		_patValItem->setText(""); 
		L_TextItem->setText(msl);
		T_TextItem->setText(mst);
		R_TextItem->setText(msr);
		B_TextItem->setText(msb);
	}
	mPixmap = pixmap;
	resizePixmapItem();
	repositionAuxItems(); 
}

void DicomView::setHighlight(bool yes)
{
	QPalette p = palette();
	if (yes) 
	{
		ischoose = true;
		p.setColor(QPalette::Text, Qt::blue/*magenta*/);
	}
	else 
	{
		ischoose = false;
		p.setColor(QPalette::Text, Qt::gray);
	}
	setPalette(p);
}

void DicomView::myZom(QWheelEvent * event)
{
	qreal fscale = pixmapItem->scale();
	if (event->delta() < 0)
	{
		fscale *= 0.9;
	}
	else
	{
		fscale *= 1.1;
	}
	pixmapItem->setTransformOriginPoint(pixmapItem->boundingRect().center());//ŵԭΪλ
	pixmapItem->setScale(fscale);

}

void DicomView::myOriginal()
{
	qreal fscale = mfscale;
	pixmapItem->setTransformOriginPoint(pixmapItem->boundingRect().center());//ŵԭΪλ
	pixmapItem->setScale(fscale);
	//getScale();
}

void DicomView::SetItemTexr()
{	
	L_TextItem->setText(msl);
	T_TextItem->setText(mst);
	R_TextItem->setText(msr);
	B_TextItem->setText(msb);

	CurFrame = dicoms->getCurFrame() + 1;
	FrameCount = dicoms->getFrameCount();
	CurFrameName = dicoms->getCurFrameName();

	dicoms->getWindow(winCenter, winWidth);
	dicoms->getsliceThickness(sliceThickness);
	dicoms->getSeriesSize(w, h, s);
	dicoms->getPatienVsl(patientID, patientName, patientBirth, patientSex, patientAge);
	
	patTxt = "Id:" + patientID + "\r\nName:" + patientName + "\r\nBirth:" + patientBirth.toString("yyyy-MM-dd") + "\r\nSex:" + patientSex + "\r\nAge:" + patientAge;

	_patValItem->setText(patTxt);
	curFrameItem->setText(QString::fromLocal8Bit("ǰ֡:%1 - ֡:%2").arg(CurFrame).arg(FrameCount));
	_pdicomsSizeItem->setText(QString::fromLocal8Bit("ͼ:%1mm - ͼ:%2mm").arg(w).arg(h)); 
	_pWLValueItem->setText(tr("W:%1, L:%2, SL:%3mm").arg(winWidth).arg(winCenter).arg(sliceThickness));
}

void DicomView::getScale()
{
	if ((isZom == false) && (m_isTranslate == false))
		mfscale = pixmapItem->scale();
}

void DicomView::SaveImage(QString mName)
{
	mPixmap.save(mName);
}

void DicomView::Play(int mindex, QPushButton *pBtn)
{
	//һ汾ɼ
}

void DicomView::Paint(QPixmap & pix)
{
	/*QPainter pp(&pix);
	
	pp.setCompositionMode(QPainter::CompositionMode_SourceIn);    //ûˢģʽCompositionMode_SourceOutģʽΪĿͼϡ
	pp.setPen(QPen(QBrush(Qt::red), 2, Qt::SolidLine));           //û(ɫ,߿,ʽ(ʵ))
	pp.setRenderHint(QPainter::Antialiasing, true);               //߶η
	QFont font = pp.font();                                       //
	font.setPixelSize(20);                                        //ıС
	font.setBold(false);                                          //ǷӴ
	pp.setFont(font);                                             //

	if (Mark == T_Arrow)//ͷ
	{
		float x1 = begin.x();                                     //ȡpoints[0]x
		float y1 = begin.y();                                     //ȡpoints[0]y
		float x2 = end.x();                                       //ȡpoints[count-1]յx
		float y2 = end.y();                                       //ȡpoints[count-1]յy
		float l = 10.0;                                           //ͷĳ
		float a = 0.5;                                            //ͷ߶νǶ
		float x3 = x2 - l * cos(atan2((y2 - y1), (x2 - x1)) - a); //ͷյ㣨x3,y3
		float y3 = y2 - l * sin(atan2((y2 - y1), (x2 - x1)) - a);
		float x4 = x2 - l * sin(atan2((x2 - x1), (y2 - y1)) - a);  //ͷյ㣨x4,y4
		float y4 = y2 - l * cos(atan2((x2 - x1), (y2 - y1)) - a);
		pp.drawLine(x2, y2, x3, y3);                               //Ƽͷ(x2,y2,x3,y3)
		pp.drawLine(x2, y2, x4, y4);                               //Ƽͷ(x2,y2,x4,y4)
		pp.drawLine(begin, end);                                   //ɼͷ(begin,end)
	}*/
}

void DicomView::MarkPressEvent(QMouseEvent * event)
{
	if (event->button() == Qt::LeftButton)
	{
		scene->pBtn = pDVBtn;
		if (mSceneState == S_Begin) 
		{
			m_beginPos = mapToScene(event->pos());
			emit drawImage(m_beginPos, m_beginPos, Mark, mSceneState);
			mSceneState = S_Moving;
		}
		else if (mSceneState == S_Moving) 
		{
			m_endPos = mapToScene(event->pos());
			switch ( Mark )
			{
			case T_Point:
			case T_Polygon:
			case T_Bezier:
				emit drawImage(m_beginPos, m_endPos, Mark, S_Press);
			case T_Line:
			case T_Arrow:
			case T_Text:
			case T_Circle:
			case T_Ellipse:
			case T_Rect:
			case T_RoundRect:
				mSceneState = S_End;
				emit drawImage(m_beginPos, m_endPos, Mark, mSceneState);
				break;
			default:break;
			}
		}
	}
	else if (event->button() == Qt::RightButton)
	{
		if (mSceneState == S_Moving) 
		{
			m_endPos = mapToScene(event->pos());
			if (Mark == T_Point || Mark == T_Polygon || Mark == T_Bezier)
			{
				mSceneState = S_End;
				emit drawImage(m_endPos, m_endPos, Mark, mSceneState);
			}
		}
	}
}

void DicomView::MarkMoveEvent(QMouseEvent * event)
{
	if (mSceneState == S_Moving)
	{
		m_movingPos = mapToScene(event->pos());
		emit drawImage(m_beginPos, m_movingPos, Mark, mSceneState);
	}
}

int DicomView::MarkItems()
{
	return scene->m_itemList.size();
}

void DicomView::DelMarkItems()
{
	scene->DelItems();
}

void DicomView::setCurFrameItem(int index)
{
	if (!dicoms || !dicoms->isNormal())
		return;
	
	SetItemTexr();
	
	if (dicoms->getCurFrame() != index)
	{
		dicoms->gotoFrame(index);
		updateView();
	}
}

// 갴סʱ
void DicomView::mousePressEvent(QMouseEvent * event)
{
	if ( dicoms && dicoms->isNormal())
	{
		QPointF sp = mapToScene(event->pos());
		QPointF ip = pixmapItem->mapFromScene(sp);
		prevMousePos = event->pos();
		emit clicked(dicoms->getViewType());
		if (ischoose)
		{
			//getScale();			
			if (Mark == T_None)
			{
				if (event->button() == Qt::LeftButton)
				{
					if (status == Browse)
					{
						if (m_isTranslate == false)
							pixmapItem->setFlag(QGraphicsItem::ItemIsMovable, false);
					}
					if (status == Pan)
					{
						m_isTranslate = true;
						pixmapItem->setFlag(QGraphicsItem::ItemIsMovable, true);
					}
				}
			}
			else
			{
				MarkPressEvent(event);
			}
			QGraphicsView::mousePressEvent(event);
		}		
	}
}
// ƶʱ
void DicomView::mouseMoveEvent(QMouseEvent * event)
{
	if (dicoms && dicoms->isNormal())
	{
	    if (ischoose)
		{
			QPointF sp = mapToScene(event->pos());
			QPointF ip = pixmapItem->mapFromScene(sp);
			if (pixmapItem->contains(ip)) 
			{
				QPoint pos = ip.toPoint();
				QString s = dicoms->getPixelValue(pos.x(), pos.y());
				posValueItem->setText(QString::fromLocal8Bit(":(X:%1, Y:%2):").arg(pos.x()).arg(pos.y()) + s);
			}

			if (Mark == T_None)
			{
				if (event->button() == Qt::LeftButton)
				{
					if (status == Browse)
					{

					}
					if (status == Pan)
					{
						if (m_isTranslate)
						{
							pixmapItem->setFlag(QGraphicsItem::ItemIsMovable, true);
						}
					}
				}
			}
			else
			{
				MarkMoveEvent(event);
			}
		}
		if (isPrevMouse == true)
		{
			// λ
		
		}
		QGraphicsView::mouseMoveEvent(event);
	}
}
// ͷź󴥷
void DicomView::mouseReleaseEvent(QMouseEvent * event)
{
	if ( dicoms&&dicoms->isNormal())
	{
		if (ischoose)
		{		
			if (event->button() == Qt::LeftButton)
			{
				if (status == Browse)
				{

				}
				if (status == Pan)
				{
					m_isTranslate = false;

				}
			}
			QGraphicsView::mouseReleaseEvent(event);
		}
	}	
}
//˫
void DicomView::mouseDoubleClickEvent(QMouseEvent * event)
{
	if (dicoms&&dicoms->isNormal())
	{
		if (ischoose)
		{
			if (event->button() == Qt::LeftButton) 
			{
				//QMessageBox::information(this, QString::fromLocal8Bit("ʾ"), QString::fromLocal8Bit("ڴ˫ ing"));
				//centerOn(pixmapItem->pixmap().width() / 2, pixmapItem->pixmap().height() / 2);
			}
			QGraphicsView::mouseDoubleClickEvent(event);
		}
	}
}

void DicomView::paintEvent(QPaintEvent * event)
{
	//Paint(pixmapItem->pixmap());
	try
	{
		QGraphicsView::paintEvent(event);
	}
	catch (...){}
}

void DicomView::wheelEvent(QWheelEvent * event)
{
	if (dicoms == 0 || !dicoms->isNormal()) 
		return;

	if (ischoose)
	{
		if (isZom == true)
		{
			myZom(event);
		}
		else
		{
			QPoint delta = event->angleDelta();
			if (delta.y() > 0) dicoms->prevFrame();
			else if (delta.y() < 0) dicoms->nextFrame();
			updateView();
		}
	}
}

void DicomView::resizeEvent(QResizeEvent * event)
{
	resizePixmapItem();
	repositionAuxItems();
	myOriginal();
	
}