#pragma once
#include <QtWidgets/QApplication>
#include <QDesktopWidget>
#include <QVariant>//
#include <QBoxLayout>
#include <QGraphicsView>
#include <QTime>
#include <QScrollBar>
#include <QCoreApplication>
#include <QtWidgets/QPushButton>
#include <qevent.h>
#include "DicomScene.h"
#include "myGobal.h"
#include "SeriesBase.h"

class QGraphicsPixmapItem;
class QGraphicsWidget;
class DicomView : public QGraphicsView
{
	Q_OBJECT

public:
	DicomView(QWidget *parent=0);
	~DicomView();

	void setSeries(SeriesBase *series);
	void resizePixmapItem(); // ڸıʱ
	void repositionAuxItems(); // ڸıʱ
	void updateView();
	void setHighlight(bool yes);
	void myZom(QWheelEvent * event);
	void myOriginal();
	void SetItemTexr();
	void getScale();
	void SaveImage(QString mName);
	void Play(int mindex, QPushButton *pBtn);
	void Paint(QPixmap & pix);
	void MarkPressEvent(QMouseEvent * event);
	void MarkMoveEvent(QMouseEvent * event);
	int  MarkItems();
	void DelMarkItems();

	//********************************************************************
	bool isZom = false,isPlay = false;	
	bool isBtn = false;
	QString msl, mst, msr, msb;
	int CurFrame, FrameCount;
	QString CurFrameName = "";
	QPixmap mPixmap; int playindex = 0;
	viewStatus status; MarkType Mark;
	SceneState mSceneState;
	QPointF m_beginPos;
	QPointF m_movingPos;
	QPointF m_endPos;
	QPushButton *pDVBtn = 0;
	bool isPrevMouse = false;
	//*******************************************************************

public slots:
	void setCurFrameItem(int);

signals:
	void windowChanged();// λıź
	void clicked(SeriesBase::ViewType);
	void drawImage(QPointF beginPos, QPointF nextPos, int type, int state);

protected:
	void mousePressEvent(QMouseEvent *event);
	void mouseMoveEvent(QMouseEvent *event);
	void mouseReleaseEvent(QMouseEvent *event);
	void mouseDoubleClickEvent(QMouseEvent *event);
	void paintEvent(QPaintEvent * event);
	void wheelEvent(QWheelEvent *event);
	void resizeEvent(QResizeEvent *event);
	QSize sizeHint() const { return hintSize; }

private: 
	bool ischoose = false;
	bool m_isMoving;
	qreal m_translateSpeed;  // ƽٶ
	qreal m_zoomDelta;  // ŵ
	qreal m_scale;  // ֵ
	QPointF m_lastPos;
	QCursor* m_cursor;
	bool m_isTranslate;
	QPoint m_lastMousePos;
	qreal mfscale = 1.0;
	
	//**********************************
	//QGraphicsScene *scene;// 
	DicomScene *scene;// 
	QGraphicsPixmapItem *pixmapItem;// еͼ
	QGraphicsSimpleTextItem *_pWLValueItem;  //ı ʾǰλֵ
	QGraphicsSimpleTextItem *_pdicomsSizeItem;
	QGraphicsSimpleTextItem *_patValItem;
	QGraphicsSimpleTextItem *posValueItem;// ʾǰֵ
	QGraphicsSimpleTextItem *curFrameItem; // ʾǰ֡
	QGraphicsWidget *slider;// 
	QGraphicsSimpleTextItem *L_TextItem;
	QGraphicsSimpleTextItem *T_TextItem; 
	QGraphicsSimpleTextItem *R_TextItem; 
	QGraphicsSimpleTextItem *B_TextItem;
	QGraphicsTextItem *TmpItem;

	SeriesBase *dicoms;
	QSize hintSize;
	double factor;
	double fixFactor;// xspace/yspace
	QPoint prevMousePos;
};
