#include "Image.h"
#include "ColorIndexTable.h"
#include "myGobal.h"

#include "dcmtk/dcmdata/dcfilefo.h"
#include "dcmtk/dcmimgle/dcmimage.h"
#include "dcmtk/dcmdata/dcdeftag.h"
#include "dcmtk/dcmdata/dctk.h"  
#include "dcmtk/dcmdata/dcrledrg.h" 
#include "dcmtk/dcmimage/diregist.h"
#include "dcmtk/dcmjpeg/djdecode.h"

#include <qdebug.h>

Image::Image(const QString &file):dcmff(new DcmFileFormat), dcmImage(0)
{
	DcmName = file;
	OFCondition oc = dcmff->loadFile(OFFilename(file.toLocal8Bit()));
	if (oc.bad())
	{
		qDebug() << "Fail:" << oc.text();
		DcmName = "";
		return; // ʱ dcmImage=0 ִinit()
	}
	// if (isGetImg)
		init();
}

Image::~Image()
{
	if (dcmImage)
	{
		delete dcmImage; 
		dcmImage = 0;
		dcmff = 0;
		/*dcmImageʱCIF_TakeOverExternalDatasetֻdelete dcmImage*/
	}
	else {
		delete dcmff; dcmff = 0;
	}
}

bool Image::isNormal() const
{
	try
	{
		return dcmImage && (dcmImage->getStatus() == EIS_Normal);
	}
	catch (...)
	{
		return false;
	}
}

void Image::init()
{
	QString tmp;
	DcmDataset *dataset = 0;
	OFCondition result;
	const char *value = NULL;
	if (!(dataset = dcmff->getDataset()))
		return;

	// ͷϢȡ
	result = dataset->findAndGetString(DCM_SeriesInstanceUID, value);
	if (result.bad())
		return;
	seriesUID = QString::fromLatin1(value);

	result = dataset->findAndGetString(DCM_InstanceNumber, value);
	if (result.bad())
		return;
	instanceNumber = QString(value);

	//mz add 2021-10-26----------------------------------------------
	// Ϣ
	result = dataset->findAndGetString(DCM_PatientID, value); // 
	patientID = QString::fromLocal8Bit(value);

	//
	result = dataset->findAndGetString(DCM_PatientName, value);
	patientName = QString::fromLocal8Bit(value);

	result = dataset->findAndGetString(DCM_PatientBirthDate, value);
	tmp = QString::fromLocal8Bit(value);
	patientBirth = QDate::fromString(tmp, "yyyyMMdd");

	result = dataset->findAndGetString(DCM_PatientSex, value);// Ա
	patientSex = QString::fromLocal8Bit(value);

	result = dataset->findAndGetString(DCM_PatientAge, value);// 
	patientAge = QString::fromLocal8Bit(value);

	// study information
	result = dataset->findAndGetString(DCM_StudyInstanceUID, value);
	studyUid = QString::fromLatin1(value);

	result = dataset->findAndGetString(DCM_StudyDate, value);
	tmp = QString::fromLocal8Bit(value);
	StudyDate = QDate::fromString(tmp, "yyyyMMdd");

	result = dataset->findAndGetString(DCM_StudyTime, value);
	tmp = QString::fromLocal8Bit(value);
	StudyTime = QDate::fromString(tmp, "yyyyMMdd");

	result = dataset->findAndGetString(DCM_StudyDescription, value);
	studyDes = QString::fromLocal8Bit(value);

	result = dataset->findAndGetString(DCM_ProtocolName, value);
	if (result.bad())
	{
		procId = "";// ûжȡ;
	}
	else
		procId = QString::fromLocal8Bit(value);// ȡɹ

	result = dataset->findAndGetString(DCM_BodyPartExamined, value);
	bodyPart = QString::fromLocal8Bit(value);

	result = dataset->findAndGetString(DCM_PatientPosition, value);
	bodyPos = QString::fromLocal8Bit(value);
	   
	//series information
	result = dataset->findAndGetString(DCM_Manufacturer, value);
	manufacturer = QString::fromLocal8Bit(value);

	result = dataset->findAndGetString(DCM_Modality, value);
	modality = QString::fromLocal8Bit(value);

	result = dataset->findAndGetString(DCM_ManufacturerModelName, value);
	modelName = QString::fromLocal8Bit(value);

	result = dataset->findAndGetString(DCM_AccessionNumber, value);
	accessionNumber = QString::fromLatin1(value);

	result = dataset->findAndGetString(DCM_SeriesInstanceUID, value);
	seriesUid = QString::fromLatin1(value);

	result = dataset->findAndGetString(DCM_SeriesNumber, value);
	seriesNumber = QString::fromLatin1(value);

	result = dataset->findAndGetString(DCM_SeriesDescription, value);
	seriesDes = QString::fromLocal8Bit(value);

	//instance information
	result = dataset->findAndGetString(DCM_SOPInstanceUID, value);
	instanceUid = QString::fromLatin1(value);

	result = dataset->findAndGetString(DCM_SOPClassUID, value);
	sopClassUid = QString::fromLatin1(value);

	result = dataset->findAndGetString(DCM_InstanceNumber, value);
	_instanceNumber = QString(value);

	result = dataset->findAndGetString(DCM_AcquisitionDate, value);
	if (value == NULL)
		result = dataset->findAndGetString(DCM_ContentDate, value);
	tmp = QString::fromLocal8Bit(value);
	acquisitionTime = QDate::fromString(tmp, "yyyyMMdd");

	/*result = dataset->findAndGetString(DCM_AcquisitionTime, value);
	if (value == NULL)
		result = dataset->findAndGetString(DCM_ContentTime, value);
	acquisitionTime.setTime(formatDicomTime(QString::fromLatin1(value)));*/

	result = dataset->findAndGetString(DCM_InstitutionName, value);
	institution = QString::fromLocal8Bit(value);

	result = dataset->findAndGetString(DCM_PatientPosition, value);
	patientPostion = QString::fromLatin1(value);

	result = dataset->findAndGetString(DCM_RequestingPhysician, value);
	reqPhysician = QString::fromLocal8Bit(value);

	result = dataset->findAndGetString(DCM_PerformingPhysicianName, value);
	perPhysician = QString::fromLocal8Bit(value);


	/*******ͼϢ*******/
	// ؼ
	result = dataset->findAndGetFloat64(DCM_PixelSpacing, pixelSpacingY, 0);
	result = dataset->findAndGetFloat64(DCM_PixelSpacing, pixelSpacingX, 1);
	result = dataset->findAndGetFloat64(DCM_SliceThickness, sliceThickness);

    // ʵʼλ
	result = dataset->findAndGetFloat64(DCM_ImagePositionPatient, startX, 0);
	result = dataset->findAndGetFloat64(DCM_ImagePositionPatient, startY, 1);
	result = dataset->findAndGetFloat64(DCM_SliceLocation, sliceLocation);

	result = dataset->findAndGetFloat64(DCM_RescaleIntercept, intercept);
	//-----------------------------------------------------------------

	result = dataset->findAndGetFloat64(DCM_PixelSpacing, spaceY, 0);
	if (result.bad())
		spaceY = 1;

	result = dataset->findAndGetFloat64(DCM_PixelSpacing, spaceX, 1);
	if (result.bad())
		spaceX = 1;

	result = dataset->findAndGetFloat64(DCM_SliceThickness, spaceZ);
	if (result.bad())
		spaceZ = 1;

	result = dataset->findAndGetFloat64(DCM_WindowWidth, winWidth);
	result = dataset->findAndGetFloat64(DCM_WindowCenter, winCenter);

	// DcmImage
	/********ѹ**********/
	bool isYaSuo = 0;
	std::string losslessTransUID = "1.2.840.10008.1.2.4.70";
	std::string lossTransUID = "1.2.840.10008.1.2.4.51";
	std::string losslessP14 = "1.2.840.10008.1.2.4.57";
	std::string lossyP1 = "1.2.840.10008.1.2.4.50";
	std::string lossyRLE = "1.2.840.10008.1.2.5";

	E_TransferSyntax xfer = dataset->getOriginalXfer();
	const char*	transferSyntax = NULL;
	dcmff->getMetaInfo()->findAndGetString(DCM_TransferSyntaxUID, transferSyntax);
	
	if (transferSyntax == NULL)
		isYaSuo = false;// ѹ
	else {
		
		if (transferSyntax == losslessTransUID || transferSyntax == lossTransUID ||
			transferSyntax == losslessP14 || transferSyntax == lossyP1)
		{
			//ѹͼؽнѹ
			DJDecoderRegistration::registerCodecs();
			dataset->chooseRepresentation(EXS_LittleEndianExplicit, NULL);
			DJDecoderRegistration::cleanup();
			isYaSuo = true;// ѹ
		}
		else if (transferSyntax == lossyRLE)
		{
			DcmRLEDecoderRegistration::registerCodecs();
			dataset->chooseRepresentation(EXS_LittleEndianExplicit, NULL);
			DcmRLEDecoderRegistration::cleanup();
			isYaSuo = true;// ѹ
		}
		else
		{
			isYaSuo = false;// ѹ
		}

	}

	if (isYaSuo)
	{
		dcmImage = new DicomImage((DcmObject*)dataset, dataset->getOriginalXfer(), CIF_TakeOverExternalDataset);
		if (dcmImage->getStatus() == EIS_Normal) {

			imageWidth = dcmImage->getWidth();
			imageHeight = dcmImage->getHeight();
			if (winWidth < 1) {
				// ôλ
				dcmImage->setRoiWindow(0, 0, imageWidth, imageHeight);
				// ¶winCenter, winWidthֵ
				dcmImage->getWindow(winCenter, winWidth);
			}
		}
	}
	else
	{
		dcmImage = new DicomImage(dcmff, dataset->getOriginalXfer(), CIF_TakeOverExternalDataset);
		if (dcmImage->getStatus() == EIS_Normal) {
			imageWidth = dcmImage->getWidth();
			imageHeight = dcmImage->getHeight();
			if (winWidth < 1) {
				dcmImage->setRoiWindow(0, 0, imageWidth, imageHeight);
				dcmImage->getWindow(winCenter, winWidth);
			}
		}
	}
}

int Image::getInstanceNumber()
{
	return instanceNumber.toInt();
}

bool Image::getPixSpacing(double & spacingX, double & spacingY, double & spacingZ) const
{
	if (isNormal()) {
		spacingX = spaceX;
		spacingY = spaceY;
		spacingZ = spaceZ;
		return true;
	}
	return false;
}

bool Image::getImageSize(int & width, int & height) const
{
	if(!isNormal())
		return false;
	width = imageWidth; height = imageHeight;
	return true;
}

bool Image::getPixmap(QPixmap & pixmap)
{
	if (isNormal()) {
		dcmImage->setWindow(winCenter, winWidth);
		return DicomImageToPixmap(*dcmImage, pixmap);
	}
	return false;
}

QString Image::getPixInfo(int x, int y)
{
	if (!isNormal())
		return"";

	if (dcmImage->isMonochrome())
	{
		const DiPixel* pixel = dcmImage->getInterData();

		//ȡͼص㣨x,y) λõֵ value
		qint64 value = 0;
		if (pixel && (x < imageWidth) && (x >= 0)
			&& (y <imageHeight) && (y >= 0)) {

			EP_Representation r = pixel->getRepresentation(); // ȡ͡
			switch (r) {
			case EPR_Sint8:
				value = *((qint8*)(pixel->getData()) + (y * imageWidth + x));
				break;
			case EPR_Uint8:
				value = *((quint8*)(pixel->getData()) + (y * imageWidth + x));
				break;
			case EPR_Sint16:
				value = *((qint16*)(pixel->getData()) + (y * imageWidth + x));
				break;
			case EPR_Uint16:
				value = *((quint16*)(pixel->getData()) + (y * imageWidth + x));
				break;
			case EPR_Sint32:
				value = *((qint32*)(pixel->getData()) + (y * imageWidth + x));
				break;
			case EPR_Uint32:
				value = *((quint32*)(pixel->getData()) + (y * imageWidth + x));
				break;
			}
		}
	
		return QStringLiteral("Ҷֵ%1").arg(value); // ַʹQStringLiteral
	}else
	{
		unsigned char * pixelDate = (unsigned char *)dcmImage->getOutputData(8, 0, 0);

		// صĵ㣨x,y) µRGBֵ
		int B = 0; int G = 0; int R = 0;
		if (pixelDate && (x < imageWidth) && (x >= 0)
			&& (y < imageHeight) && (y >= 0))
		{
			 B = *(pixelDate + y*imageWidth * 3 + x * 3 + 2);
			 G = *(pixelDate + y*imageWidth * 3 + x * 3 + 1);
			 R = *(pixelDate + y*imageWidth * 3 + x * 3);
		}
		return QStringLiteral("R:%1, G:%2, B:%3").arg(R).arg(G).arg(B); // ַʹQStringLiteral
	}
}

bool Image::isMonochrome()
{
	return dcmImage->isMonochrome();
}

const DiPixel * Image::getInternalPtr()
{
	return isNormal() ? dcmImage->getInterData() : nullptr;
}

bool Image::DicomImageToPixmap(DicomImage & dcmImage, QPixmap & pixmap)
{
	bool res = true;

	void *pDIB = NULL;
	int size = 0;
	if (dcmImage.isMonochrome())
	{
		// Ҷͼ
		size = dcmImage.createWindowsDIB(pDIB, 0, 0, 8, 1, 1);
		if (!pDIB)
			return false;

		res=UcharArrayToPixmap((uchar *)pDIB, dcmImage.getWidth(), dcmImage.getHeight(), size, pixmap);
		
	}
	else
	{
		// RGBͼ
		size = dcmImage.createWindowsDIB(pDIB, 0, 0, 24, 1, 1);
		if (!pDIB)
			return false;
		res = UcharArrayToPixmap((uchar *)pDIB, dcmImage.getWidth(), dcmImage.getHeight(), size, pixmap,24);

	}

	delete pDIB;
	return res;
}

bool Image::UcharArrayToPixmap(uchar *data, int w, int h, int bitSize, QPixmap & pixmap, int biBitCount)
{
	//λͼļĲɣBITMAPFILEHEADER,BITMAPINFOHEADER,ɫ,Image Data
	BITMAPFILEHEADER lpfh;// ļͷ  ̶14ֽ, ļйϢ
	BITMAPINFOHEADER lpih;// ̶40ֽڣͼйϢ

	ColorIndexTable rgbquad((ColorIndexTable::ColorMode)color);
	RGBQUAD *palette = rgbquad.palette;// ɫRGBQUADĴС256

	memset(&lpfh, 0, sizeof(BITMAPFILEHEADER));
	lpfh.bfType = 0x4d42;//'B''M' must be 0x4D42.
						 //the sum bits of BITMAPFILEHEADER,BITMAPINFOHEADER and RGBQUAD;the index byte of the image data.
	lpfh.bfOffBits = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + rgbquad.getPaletteBits();


	memset(&lpih, 0, sizeof(BITMAPINFOHEADER));
	lpih.biSize = sizeof(BITMAPINFOHEADER); //the size of this struct. it is 40 bytes.
	lpih.biWidth = w;
	lpih.biHeight = h;
	lpih.biCompression = BI_RGB;
	lpih.biPlanes = 1; //must be 1. 


	void *pDIB = data;
	int size = bitSize;
	lpih.biBitCount = biBitCount;


	//the size of the whole bitmap file.
	lpfh.bfSize = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + rgbquad.getPaletteBits() + size;

	QByteArray bmp;
	bmp.append((char*)&lpfh, sizeof(BITMAPFILEHEADER));
	bmp.append((char*)&lpih, sizeof(BITMAPINFOHEADER));
	bmp.append((char*)palette, rgbquad.getPaletteBits());
	bmp.append((char*)pDIB, size);
	
	return pixmap.loadFromData(bmp);
}

void Image::setRoiWindow(const QRectF & rect)
{
	if (!isNormal())
		return;

	dcmImage->setRoiWindow(rect.left(), rect.top(), rect.width(), rect.height());
	dcmImage->getWindow(winCenter, winWidth);
}

int Image::color=0;
