#pragma once
#include <QMap>
#include <QRectF>
#include <QPixmap>
#include <QDateTime>
#include <QTimer>

class Image;
class QSlider;
class SeriesBase
{
public:
	enum ViewType
	{
		XY = 0,
		XZ = 1,
		YZ = 2
	};

	SeriesBase();
	virtual ~SeriesBase();
	QSlider *slider; // ƬλõĿؼ

	static void readSeriesUid(QString &s); // ȡ
	static void append(Image*);
	static bool isNormal(); // ȡ꣬Ƿǿõdicoms
	
	// αɫʹλ
	static void setColor(int color);
	
	static void setWindow(const double &center, const double &width)
	{
		winCenter = center; winWidth = width;
	}
	static void setWindowDelta(const double &dCenter, const double &dWidth)
	{
		winCenter += dCenter; winWidth += dWidth;
	}
	static void setRoiWindow(const QRectF &rect); // ֻXYͼЧ
	static void setDefaultWindow()
	{
		winCenter = defCenter; winWidth = defWidth;
	}
	static void getWindow(double &center, double &width)
	{
		center = winCenter; width = winWidth;
	}
	static void getSeriesSize(int &w, int&h, int&s)
	{
		w = imageWidth; h = imageHeight; s = dicomsSize;
	}
	//mz add ----------------------------------------------------------------------

	static void getDcmName(QString & mDcmName)
	{
		mDcmName = DcmName;
	}

	static void getsliceThickness(double & msliceThickness)
	{
		msliceThickness = sliceThickness;
	}
	//-----------------------------------------------------------------------------
	
	const ViewType getViewType()
	{
		return vt;
	}

	/*--麯--*/
	virtual void nextFrame() = 0;
	virtual void prevFrame() = 0;
	virtual void gotoFrame(int index) = 0;
	virtual void gotoFrame_2(int index) = 0;
	virtual bool getPixmap(QPixmap &pixmap) = 0;
	
	virtual int getCurFrame() = 0;
	virtual int getFrameCount() = 0;
	virtual bool getRectSize(int &x_width, int &y_height) = 0;
	virtual QString getCurFrameName() = 0;
	virtual void getPatienVsl(QString &mID, QString &mName, QDate &mBirth, QString &mSex, QString &mAge) = 0;
	
	virtual bool getPixSpacing(double &xs, double &ys) = 0; // ͼй
	virtual QString getPixelValue(int x, int y) = 0;
	virtual void update();
	

protected:
	static QString UID; //Ψһʶ
	static QMap<int, Image*> dicoms;// 
	static const qint32** volume; // άݣYZXZͼ
	static int volumeSlices; // άqint32*[]ĸYZXZͼ
	static void createVolume();
	static void deleteVolume();

	static int curXYFrame;// ǰͼ
	static int curXZFrame;
	static int curYZFrame;
	ViewType vt; // ͼʽ
	static bool hasTreeView; // ɫûͼ

	static double winCenter; // λ
	static double winWidth; // 
	static double defCenter;// Ĭϴλ
	static double defWidth;

	static int imageWidth;
	static int imageHeight;
	static int dicomsSize;

	//mz add----------------------------------------------
	//
	static QString	patientID;
	//
	static QString	patientName;
	//
	static QDate  patientBirth;
	//Ա
	static QString	patientSex;
	//
	static QString	patientAge;
	//
	static QString DcmName;
	//
	static double sliceThickness;
};
