#include "YZSeries.h"
#include <qslider.h>
#include "Image.h"


YZSeries::YZSeries():SeriesBase()
{
	vt = SeriesBase::YZ;
}


YZSeries::~YZSeries()
{
}

void YZSeries::nextFrame()
{
	++curYZFrame;
	if (curYZFrame >= imageWidth)
		curYZFrame = 0;
	slider->setValue(curYZFrame);
}

void YZSeries::prevFrame()
{
	--curYZFrame;
	if (curYZFrame < 0)
		curYZFrame = imageWidth - 1;
	slider->setValue(curYZFrame);
}

void YZSeries::gotoFrame(int index)
{
	index < 0 ? index = 0 : index = index;
	index >= imageWidth ? index = imageWidth - 1 : index = index;

	curYZFrame = index;
	slider->setValue(curYZFrame);
}

void YZSeries::gotoFrame_2(int index)
{
	index < 0 ? index = 0 : index = index;
	index >= imageWidth ? index = imageWidth - 1 : index = index;

	curYZFrame = index;
}

bool YZSeries::getPixmap(QPixmap & pixmap)
{
	if (!hasTreeView)
		return false;

	size_t size = imageHeight * dicomsSize;
	uchar *pDIB = new uchar[size];
	memset(pDIB, 0, sizeof(uchar)*size);
	double center = winCenter;
	double width = winWidth;
	double factor = 255 / width;
	double lower = center - width / 2;

	/*>>>>>>>>>>>>>ֵ*/
	for (uint y = 0; y < dicomsSize; ++y) {
		const qint32 *ptr = volume[y];
		int bmpIdx = (dicomsSize - 1 - y) * imageHeight;
		if (ptr) {
			for (uint x = 0; x < imageHeight; ++x) {
				qint32 val = ptr[x*imageWidth + curYZFrame];
				if (val > lower + width) pDIB[bmpIdx + x] = 255;
				else if (val > lower) pDIB[bmpIdx + x] = (val - lower)*factor;
			}
		}
	}

	bool res = Image::UcharArrayToPixmap(pDIB, imageHeight, dicomsSize, size, pixmap, 8);
	delete pDIB;
	return res;
}

int YZSeries::getCurFrame()
{
	return curYZFrame;
}

int YZSeries::getFrameCount()
{
	if (!hasTreeView)
		return 0;
	return imageWidth;
}

bool YZSeries::getRectSize(int & x_width, int & y_height)
{
	if (isNormal() && hasTreeView)
	{
		x_width = imageHeight;
		y_height = dicoms.size();
		return true;
	}
	return false;
}

QString YZSeries::getCurFrameName()
{
	if (isNormal())
	{
		DcmName = dicoms.values().at(curXYFrame)->getDcmName();
		return DcmName;
	}
	return "";
}

void YZSeries::getPatienVsl(QString & mID, QString & mName, QDate & mBirth, QString & mSex, QString & mAge)
{	
	//
	mID = patientID;
	//
	mName = patientName;
	//
	mBirth = patientBirth;
	//Ա
	mSex = patientSex;
	//
	mAge = patientAge;
}

bool YZSeries::getPixSpacing(double & xs, double & ys)
{
	if (isNormal() && hasTreeView)
	{
		double d;
		return dicoms.values().first()->getPixSpacing(d, xs, ys);
	}
	return false;
}

QString YZSeries::getPixelValue(int x, int y)
{
	if (isNormal() && hasTreeView)
	{
		if (y < 0) y = 0;
		if (y >= dicomsSize) y = dicomsSize - 1;
		return dicoms.values().at(y)->getPixInfo(curYZFrame, x);
	}
	return "";
}
